#ifndef _MELANGEFS_H
#define _MELANGEFS_H_

// FUSE API changes frequently; so you need to define which version of the API
// is being used by your file system. Let's stick with version 26 for now.
//
#define FUSE_USE_VERSION 26

#include <limits.h>
#include <stdio.h>

#define DEFAULT_SSD         "/mnt/ssd/"
#define DEFAULT_HDD         "/mnt/hdd/"
#define DEFAULT_THRESHOLD   4096

// maintain melangefs state in here
// -- add more fields that you feel are important
//
struct melange_state {
    char *ssd;
    char *hdd;
    int threshold;
};

// some useful macros, if you want
//
#define MELANGE_DATA ((struct melange_state *) fuse_get_context()->private_data)

#define MELANGE_SSD \
    ((struct melange_state *) fuse_get_context()->private_data)->ssd
#define MELANGE_HDD \
    ((struct melange_state *) fuse_get_context()->private_data)->hdd


#endif
