#!/bin/bash

##
## Script to start the MelangeFS file system
##

MOUNT_OR_UMOUNT_FLAG=$1     ## "m" for mount, "u" for unmount, "x" for both
MFS_MNT_POINT=$2
MFS_THRESHOLD=$3

mfs_process="../melangefs"
mfs_ssd_mount="/mnt/ssd/"
mfs_hdd_mount="/mnt/hdd/"

mkdir -p ${MFS_MNT_POINT}

if [ "$1" = "m" ]
then
    ${mfs_process} ${MFS_THRESHOLD} ${mfs_ssd_mount} ${mfs_hdd_mount} ${MFS_MNT_POINT}
elif [ "$1" = "u" ]
then
    fusermount -u ${MFS_MNT_POINT}
    rm -rf ${mfs_ssd_mount}/*
    rm -rf ${mfs_hdd_mount}/*
elif [ "$1" = "x" ]
then
    fusermount -u ${MFS_MNT_POINT}
    ./umount_disks.sh ${mfs_ssd_mount} ${mfs_hdd_mount} 
    ./mount_disks.sh ${mfs_ssd_mount} ${mfs_hdd_mount} 
    ${mfs_process} ${MFS_THRESHOLD} ${mfs_ssd_mount} ${mfs_hdd_mount} ${MFS_MNT_POINT}
else
    echo "***ERROR"
    echo "\tUsage: ./scriptName <MODE> <MELANGEFS_MOUNT> <MELANGEFS_THRESHOLD>\n"
    echo "\n"
    echo "\twhere, MODE is one of the following ..."
    echo "\tm for mount, u for unmount, x for (unmount+mount) to drop caches\n"
fi
