#!/bin/bash

## Script to test the part 2 of the class project by performing two kinds 
## of operations storage management queries: du and find
##

TEST_TYPE=$1
MFS_MNT_POINT=$2
MFS_THRESHOLD=$3

log_file="disk_stats.log"
disk_stats="vmstat -d | grep 'sd'"
calc_stats="./stat_summarizer"

if [ "$1" = "a" ]
then
    ## unmount and remount MelangeFS
    ./melangefs_controller.sh x ${MFS_MNT_POINT} ${MFS_THRESHOLD}

    ####################
    ## Running a "du" query 
    ####################

    vmstat -d | grep 'sd' > ${log_file}
    #
    # TODO: emulating different types of aggregator queries
    # - I have included some samples (uncomment them as you wish)
    # - Consider adding more test cases to follow the specification
    #
    du -s ${MFS_MNT_POINT}              # returns total size (-s)
    #du ${MFS_MNT_POINT} | wc -l        # returns count of total files (-c)
    vmstat -d | grep 'sd' >> ${log_file}

    ## computing statistics
    sed -i 's/sdb/sdb1/g' ${log_file}
    sed -i 's/sdc/sdc1/g' ${log_file}
    echo "@ du results"
    ${calc_stats} ${log_file}

elif [ "$1" = "t" ]
then

    ## unmount and remount MelangeFS
    ./melangefs_controller.sh x ${MFS_MNT_POINT} ${MFS_THRESHOLD}

    ####################
    ## Running a "find" query 
    ####################

    vmstat -d | grep 'sd' > ${log_file}
    #
    # TODO: emulating different types of aggregator queries
    # - I have included some samples (uncomment them as you wish)
    # - Consider adding more test cases to follow the specification
    #
    find ${MFS_MNT_POINT} -size 10k             # change size as needed 
    #find ${MFS_MNT_POINT} -size 10k -gid 1000  # change size/gid
    #find ${MFS_MNT_POINT} -newer /tmp/foo      # change the file name
    vmstat -d | grep 'sd' >> ${log_file}

    ## computing statistics
    sed -i 's/sdb/sdb1/g' ${log_file}
    sed -i 's/sdc/sdc1/g' ${log_file}
    echo "@ find results"
    ${calc_stats} ${log_file}

else
    echo "*** ERROR. Only accepts one of two options: d or f\n"
    exit 1; 
fi


